<?php
namespace Teknisa\MAN\Services;

use Teknisa\MAN\Utilities\Query;
use Doctrine\ORM\EntityManager;

class CatracaService {
   
    protected $entityManager;
    
    public function __construct($entityManager) {
        $this->entityManager = $entityManager;
    }
	
    public function save ($rows){
        $params = array(
            
            ':CDFILIAL'         => $rows[0]['CDFILIAL'],
            ':CDCAIXA'          => $rows[0]['CDCAIXA'],
            ':DSENDIPCAT'       => $rows[0]['DSENDIPCAT'],
            ':CDPORTACAT'       => $rows[0]['CDPORTACAT'],
            ':DSMSGLIBERACAO'   => $rows[0]['DSMSGLIBERACAO'],
            ':DSMSGBLOQUEIO'    => $rows[0]['DSMSGBLOQUEIO'],
            ':IDMODCATRACA'     => $rows[0]['IDMODCATRACA'],
            ':NRORG'            => $rows[0]['NRORG']
            
 		);
 		$this->entityManager->getConnection()->executeQuery(self::INSERT_CATRACA, $params);
    }
    const INSERT_CATRACA = "
	    INSERT INTO CATRACA
		  (
		    CDFILIAL,
		    CDCAIXA,
		    DSENDIPCAT,
		    CDPORTACAT,
		    DSMSGLIBERACAO,
		    DSMSGBLOQUEIO,
		    IDMODCATRACA,
		    NRORG
		  )
		  VALUES
		  (
		    :CDFILIAL,
		    :CDCAIXA,
		    :DSENDIPCAT,
		    :CDPORTACAT,
		    :DSMSGLIBERACAO,
		    :DSMSGBLOQUEIO,
		    :IDMODCATRACA,
		    :NRORG
		  )";
		  
    public function update($rows) {
        $params = array(
            ':CDFILIAL'         => $rows[0]['CDFILIAL'],
            ':CDCAIXA'          => $rows[0]['CDCAIXA'],
            ':DSENDIPCAT'       => $rows[0]['DSENDIPCAT'],
            ':CDPORTACAT'       => $rows[0]['CDPORTACAT'],
            ':DSMSGLIBERACAO'   => $rows[0]['DSMSGLIBERACAO'],
            ':DSMSGBLOQUEIO'    => $rows[0]['DSMSGBLOQUEIO'],
            ':IDMODCATRACA'     => $rows[0]['IDMODCATRACA'],
            ':NRORG'            => $rows[0]['NRORG'],
        );
        $this->entityManager->getConnection()->executeQuery(self::UPDATE_CATRACA, $params);
    }

    const UPDATE_CATRACA = "
	    UPDATE CATRACA
    	  SET
    	    CDPORTACAT 		= :CDPORTACAT,
    	    DSMSGLIBERACAO 	= :DSMSGLIBERACAO,
    	    DSMSGBLOQUEIO 	= :DSMSGBLOQUEIO,
    	    IDMODCATRACA    = :IDMODCATRACA,
    	    NRORG			= :NRORG
    	  WHERE 
    	   CDFILIAL = :CDFILIAL AND CDCAIXA = :CDCAIXA AND DSENDIPCAT = :DSENDIPCAT";
    	   
    public function delete($rows) {
        $params = array(
            ':CDFILIAL'         => $rows[0]['CDFILIAL'],
            ':CDCAIXA'          => $rows[0]['CDCAIXA'],
            ':DSENDIPCAT'       => $rows[0]['DSENDIPCAT'],
            ':CDPORTACAT'       => $rows[0]['CDPORTACAT'],
            ':DSMSGLIBERACAO'   => $rows[0]['DSMSGLIBERACAO'],
            ':DSMSGBLOQUEIO'    => $rows[0]['DSMSGBLOQUEIO'],
            ':IDMODCATRACA'     => $rows[0]['IDMODCATRACA'],
            ':NRORG'            => $rows[0]['NRORG'],
        );
 		return $this->entityManager->getConnection()->executeQuery(self::DELETE_CATRACA, $params);
    }
    
   const DELETE_CATRACA = "
        DELETE FROM CATRACA 
        WHERE NRORG = :NRORG 
        AND CDFILIAL = :CDFILIAL
        AND CDCAIXA = :CDCAIXA
        AND DSENDIPCAT = :DSENDIPCAT
    ";
			 
			 
}